summaryrefslogtreecommitdiff
path: root/tests/chmod/setgid
diff options
context:
space:
mode:
Diffstat (limited to 'tests/chmod/setgid')
-rwxr-xr-xtests/chmod/setgid76
1 files changed, 76 insertions, 0 deletions
diff --git a/tests/chmod/setgid b/tests/chmod/setgid
new file mode 100755
index 0000000..d2868f9
--- /dev/null
+++ b/tests/chmod/setgid
@@ -0,0 +1,76 @@
+#!/bin/sh
+# Make sure GNU chmod works the same way as those of Solaris, HPUX, AIX
+# wrt directories with the setgid bit set.
+
+# Copyright (C) 2001, 2004, 2005, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chmod --version
+fi
+
+. $srcdir/../envvar-check
+. $srcdir/../lang-default
+
+pwd=`pwd`
+tmp=setgid.$$
+trap 'status=$?; cd "$pwd" && rm -rf $tmp && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_failure=0
+
+mkdir $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+test=../../../src/test
+
+umask 0
+mkdir d || framework_failure=1
+
+chmod g+s d 2> /dev/null && $test -g d ||
+ {
+ # This is required because on some systems (at least NetBSD 1.4.2A),
+ # it may happen that when you create a directory, its group isn't one
+ # to which you belong. When that happens, the above chmod fails. So
+ # here, upon failure, we try to set the group, then rerun the chmod command.
+
+ id_g=`id -g` &&
+ test -n "$id_g" &&
+ chgrp "$id_g" d &&
+ chmod g+s d || framework_failure=1
+ }
+
+if test $framework_failure = 1; then
+ echo 'failure in testing framework' 1>&2
+ (exit 1); exit 1
+fi
+
+# "chmod g+s d" does nothing on some NFS file systems.
+$test -g d || {
+ echo 1>&2 "$0: cannot create setgid directories," \
+ "so can't run this test"
+ exit 77
+}
+
+fail=0
+
+chmod 755 d
+
+case `ls -ld d` in drwxr-sr-x*);; *) fail=1;; esac
+
+(exit $fail); exit $fail